local B, C = unpack(select(2, ...))
-- if not C["tooltip"].enable then return end

local gcol = {.35, 1, .6}										-- Guild Color
local pgcol = {112/255, 192/255, 245/255} 									-- Player's Guild Color
local uiscale = 1.0											-- 缩放
local cursor = false										-- 鼠标跟随
local hideincombat = true
local point = {"RIGHT",UIParent,-10,-150}  --非鼠标跟随模式下鼠标提示位置
local backdrop = {

	bgFile = C.blank,
	edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=], edgeSize = B.mult,
	insets = {top = B.mult, left = B.mult, bottom = B.mult, right = B.mult},
}

local tooltips = {
	GameTooltip, 
	ItemRefTooltip, 
	ItemRefShoppingTooltip1, 
	ItemRefShoppingTooltip2, 
	ShoppingTooltip1, 
	ShoppingTooltip2, 
	ShoppingTooltip3, 
	WorldMapTooltip, 
	DropDownList1MenuBackdrop, 
	DropDownList2MenuBackdrop, 
}

local types = {
	rare = " |cffFF44FF稀有|r ",
	elite = " |cffFFFF00+|r ",
	worldboss = " |cffFF1919首领|r ",
	rareelite = " |cff9933FA稀有|r |cffFFFF00+|r ",
}

local reforgeIDs = {
	{1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8},
	{2, 1}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8},
	{3, 1}, {3, 2}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8},
	{4, 1},{4, 2},{4, 3},{4, 5},{4, 6},{4, 7},{4, 8},
	{5, 1},{5, 2},{5, 3},{5, 4},{5, 6},{5, 7},{5, 8},
	{6, 1},{6, 2},{6, 3},{6, 4},{6, 5},{6, 7},{6, 8},
	{7, 1},{7, 2},{7, 3},{7, 4},{7, 5},{7, 6},{7, 8},
	{8, 1},{8, 2},{8, 3},{8, 4},{8, 5},{8, 6},{8, 7},
}

local StatNames = {
	ITEM_MOD_SPIRIT_SHORT,
	ITEM_MOD_DODGE_RATING_SHORT,
	ITEM_MOD_PARRY_RATING_SHORT,
	ITEM_MOD_HIT_RATING_SHORT,
	ITEM_MOD_CRIT_RATING_SHORT,
	ITEM_MOD_HASTE_RATING_SHORT,
	ITEM_MOD_EXPERTISE_RATING_SHORT,
	ITEM_MOD_MASTERY_RATING_SHORT
}

for _, v in pairs(tooltips) do
	v:CreateShadow()
	-- if C["general"].uiscale >= 0.75 then sd = v:CreateShadow(nil, 3) else sd = v:CreateShadow(nil, 2) end
	v:SetBackdrop(nil)
	v.bd = CreateFrame("Frame", nil, v)
	v.bd:SetFrameLevel(v:GetFrameLevel()-1)
	v.bd:SetAllPoints(v)
	v.bd:SetBackdrop(backdrop)
	v.bd:SetBackdropColor(.05, .05, .05, .8)
	v.bd:SetBackdropBorderColor(0, 0, 0, 0)
	v:SetScale(uiscale)
	v:SetScript("OnShow", function(self)
		v:SetBackdrop(nil)
		if InCombatLockdown() and hideincombat and UnitIsPlayer(select(2, GameTooltip:GetUnit())) then self:Hide() end
		-- self:SetBackdropColor(0, 0, 0, C.general.auroraalpha)
		local item
		if self.GetItem then
			item = select(2, self:GetItem())
		elseif select(2, GameTooltip:GetUnit()) then
			unit = select(2, GameTooltip:GetUnit())
		end
		if item then
			self.shadow:Hide()
			local quality = select(3, GetItemInfo(item))
			if quality then
				local r, g, b = GetItemQualityColor(quality)
				self.bd:SetBackdropBorderColor(r, g, b)
			else
				self.bd:SetBackdropBorderColor(0, 0, 0, 1)
			end
			-- reforge
			if not IsAddOnLoaded("ReforgeLite") then 
				local regions = {self:GetRegions()}
				local itemLink = select(2, GetItemInfo(item))
				for i = 1, #regions do
					local region = regions[i]
					if region and region:GetObjectType() == "FontString" then
						local text = region:GetText()
						if text and text == REFORGED then
							local rid = tonumber(itemLink:match("item:%d+:%d+:%d+:%d+:%d+:%d+:%-?%d+:%-?%d+:%d+:(%d+)"))
							local info = reforgeIDs[rid - 113 + 1]
							if info[1] and info[2] then
								region:SetText(text.." ("..StatNames[info[1]].." -> "..StatNames[info[2]]..")")
							end
						end
					end
				end
			end
		elseif select(2, GameTooltip:GetUnit()) then
			self.shadow:Show()
			local r,g,b = unpack({GameTooltip_UnitColor(select(2, GameTooltip:GetUnit()))})
--			print (r..g..b)
			self.bd:SetBackdropBorderColor(0, 0, 0, 1)		
		else
			self.bd:SetBackdropBorderColor(0, 0, 0, 1)
		end
		if self.NumLines then
			for index=1, self:NumLines() do
				if index == 1 then
					_G[self:GetName()..'TextLeft'..index]:SetFont(C.font, 14, "THINOUTLINE")
				else
					_G[self:GetName()..'TextLeft'..index]:SetFont(C.font, 14, "THINOUTLINE")
				end
				_G[self:GetName()..'TextRight'..index]:SetFont(C.font, 14, "THINOUTLINE")
			end
		end
	end)
	v:HookScript("OnHide", function(self)
		self.bd:SetBackdropBorderColor(0, 0, 0, 1)
	end)
end

local hex = function(r, g, b)
	return ('|cff%02x%02x%02x'):format(r * 255, g * 255, b * 255)
end

local truncate = function(value)
	if value >= 1e6 then
		return string.format('%.2fm', value / 1e6)
	elseif value >= 1e4 then
		return string.format('%.1fk', value / 1e3)
	else
		return string.format('%.0f', value)
	end
end

function GameTooltip_UnitColor(unit)
	local r, g, b = 0.6, 0.6, 0.6
	if UnitPlayerControlled(unit) then
		if UnitCanAttack(unit, "player") then
			if UnitCanAttack("player", unit) then
				r = FACTION_BAR_COLORS[2].r
				g = FACTION_BAR_COLORS[2].g
				b = FACTION_BAR_COLORS[2].b

			else r,g,b = 0.4, 0.4, 0.94 end
		elseif UnitCanAttack("player", unit) then
			r = FACTION_BAR_COLORS[4].r
			g = FACTION_BAR_COLORS[4].g
			b = FACTION_BAR_COLORS[4].b
		elseif UnitIsPVP(unit) then
			r = FACTION_BAR_COLORS[6].r
			g = FACTION_BAR_COLORS[6].g
			b = FACTION_BAR_COLORS[6].b
		else r,g,b = 0.0,0.6,0.1
		end
	else
		local reaction = UnitReaction(unit, "player")
		if reaction then
			r = FACTION_BAR_COLORS[reaction].r
			g = FACTION_BAR_COLORS[reaction].g
			b = FACTION_BAR_COLORS[reaction].b
		end
	end
	if (UnitIsPlayer(unit) and not UnitCanAttack("player", unit)) then
		local class = select(2, UnitClass(unit))
		if class then
			r = RAID_CLASS_COLORS[class].r
			g = RAID_CLASS_COLORS[class].g
			b = RAID_CLASS_COLORS[class].b
		end
	end
	return r, g, b
end

GameTooltip:HookScript("OnTooltipSetUnit", function(self)
	local unit = select(2, self:GetUnit())
	local tar = nil
	if unit then
		GameTooltipStatusBar:SetStatusBarColor(unpack({GameTooltip_UnitColor(unit)}))
		
		local unitClassification = types[UnitClassification(unit)] or " "
		local creatureType = UnitCreatureType(unit) or ""
		local unitName = UnitName(unit)
		local unitLevel = UnitLevel(unit)
		local diffColor = unitLevel > 0 and GetQuestDifficultyColor(UnitLevel(unit)) or QuestDifficultyColors["impossible"]
		if unitLevel < 0 then unitLevel = '??' end
		if UnitIsPlayer(unit) then
			local unitRace = UnitRace(unit)
			local unitClass, unitClassEn = UnitClass(unit)
			local guild, rank, index = GetGuildInfo(unit)
			local temp = index + 1
			local playerGuild = GetGuildInfo("player")
			if guild then
				GameTooltipTextLeft2:SetFormattedText("<%s>"..hex(1, 1, 1).." %s ".."- %s", guild, rank, temp)
				if IsInGuild() and guild == playerGuild then
					GameTooltipTextLeft2:SetTextColor(pgcol[1], pgcol[2], pgcol[3])
				else
					GameTooltipTextLeft2:SetTextColor(gcol[1], gcol[2], gcol[3])
				end
			end
			for i=2, GameTooltip:NumLines() do
				if _G["GameTooltipTextLeft" .. i]:GetText():find(PLAYER) then
					_G["GameTooltipTextLeft" .. i]:SetText(string.format(hex(diffColor.r, diffColor.g, diffColor.b).."%s|r ", unitLevel) .. unitRace .. " " ..string.format(hex(RAID_CLASS_COLORS[unitClassEn].r, RAID_CLASS_COLORS[unitClassEn].g, RAID_CLASS_COLORS[unitClassEn].b).."%s|r ", unitClass))
					break
				end
			end
		else
			for i=2, GameTooltip:NumLines() do
				if _G["GameTooltipTextLeft" .. i]:GetText():find(LEVEL) or _G["GameTooltipTextLeft" .. i]:GetText():find(creatureType) then
					_G["GameTooltipTextLeft" .. i]:SetText(string.format(hex(diffColor.r, diffColor.g, diffColor.b).."%s|r", unitLevel) .. unitClassification .. creatureType)
					break
				end
			end
		end
		if UnitIsPVP(unit) then
			for i = 2, GameTooltip:NumLines() do
				if _G["GameTooltipTextLeft"..i]:GetText():find(PVP) then
					_G["GameTooltipTextLeft"..i]:SetText(nil)
					break
				end
			end
		end
		if not tar and UnitExists(unit.."target") then
			tar = true
			local r, g, b = GameTooltip_UnitColor(unit.."target")
			if UnitName(unit.."target") == UnitName("player") then
				text = hex(1, 0, 0)..">你<|r"
			else
				text = hex(r, g, b)..UnitName(unit.."target").."|r"
			end
			self:AddLine(TARGET..": "..text)
		end
	end
end)

--[[
GameTooltipStatusBar.bg = CreateFrame("Frame", nil, GameTooltipStatusBar)
GameTooltipStatusBar.bg:Point("TOPLEFT", GameTooltipStatusBar, "TOPLEFT", -1, 1)
GameTooltipStatusBar.bg:Point("BOTTOMRIGHT", GameTooltipStatusBar, "BOTTOMRIGHT", 1, -1)
GameTooltipStatusBar.bg:SetFrameStrata(GameTooltipStatusBar:GetFrameStrata())
GameTooltipStatusBar.bg:SetFrameLevel(GameTooltipStatusBar:GetFrameLevel() - 1)
GameTooltipStatusBar.bg:SetBackdrop(backdrop)
GameTooltipStatusBar.bg:SetBackdropColor(0, 0, 0, 0.5)
GameTooltipStatusBar.bg:SetBackdropBorderColor(0, 0, 0, 1)]]
GameTooltipStatusBar:CreateShadow("Background",3,2)
GameTooltipStatusBar.shadow:SetScript("OnUpdate", function(self)
	local unit  = select(2, GameTooltip:GetUnit())
	if unit then
		local minhealth, maxhealth = UnitHealth(unit), UnitHealthMax(unit)
	--	self:GetParent():SetMinMaxValues(0,max)
	--	self:GetParent():SetValue(minhealth)
	end
end)
GameTooltipStatusBar:SetHeight(12)
GameTooltipStatusBar:SetStatusBarTexture("Interface\\AddOns\\MyTooltip\\statusbar2")
GameTooltipStatusBar:ClearAllPoints()
GameTooltipStatusBar:SetPoint("TOPLEFT", GameTooltip, "BOTTOMLEFT", 0, -5)
GameTooltipStatusBar:SetPoint("TOPRIGHT", GameTooltip, "BOTTOMRIGHT", 0, -5)


GameTooltipStatusBar:HookScript("OnValueChanged", function(self, value)
	if not value then
		return
	end
	local min, max = self:GetMinMaxValues()
	self:SetValue(value)
	if value < min or value > max then
		return
	end
	local unit  = select(2, GameTooltip:GetUnit())
	if unit then
		if UnitIsPlayer(unit) then
			GameTooltipStatusBar:SetStatusBarColor(unpack({GameTooltip_UnitColor(unit)}))
		end
		min, max = UnitHealth(unit), UnitHealthMax(unit)
		if not self.text then
			self.text = self:CreateFontString(nil, "OVERLAY")
			self.text:SetPoint("CENTER", GameTooltipStatusBar, 0, 0)
			self.text:SetFont(C.font, 14, "THINOUTLINE")
			-- self.text:SetShadowOffset(B.mult, -B.mult)
		end
		if value ~= max then self.text:Show() end
		local hp = truncate(min).." / "..truncate(max)
		self.text:SetText(hp)
	end
end)


local iconFrame = CreateFrame("Frame", nil, ItemRefTooltip)
iconFrame:SetWidth(20)
iconFrame:SetHeight(20)
iconFrame:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", -3, 0)
iconFrame:SetBackdrop(backdrop)
iconFrame:SetBackdropColor(0, 0, 0, 0.5)
iconFrame:SetBackdropBorderColor(0, 0, 0, 1)
iconFrame2 = CreateFrame("Frame", nil, iconFrame)
iconFrame2:SetAllPoints(iconFrame)
iconFrame2:SetFrameLevel(iconFrame:GetFrameLevel()+1)
iconFrame.icon = iconFrame2:CreateTexture(nil, "BACKGROUND")
iconFrame.icon:SetPoint("TOPLEFT", 1, -1)
iconFrame.icon:SetPoint("BOTTOMRIGHT", -1, 1)
iconFrame.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)

hooksecurefunc("SetItemRef", function(link, text, button)
	if iconFrame:IsShown() then
		iconFrame:Hide()
	end
	local type, id = string.match(link, "(%l+):(%d+)") 
	if type == "item" then
		iconFrame.icon:SetTexture(select(10, GetItemInfo(id)))
		iconFrame:Show()
	elseif type == "spell" then
		iconFrame.icon:SetTexture(select(3, GetSpellInfo(id)))
		iconFrame:Show()
	elseif type == "achievement" then
		iconFrame.icon:SetTexture(select(10, GetAchievementInfo(id)))
		iconFrame:Show()
	end
end)

if cursor then
	local tooltipholder = CreateFrame("Frame", nil, UIParent)
	tooltipholder:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -50, 160)
	tooltipholder:SetFrameStrata("TOOLTIP")
	tooltipholder:SetSize(120, 20)
end
		
hooksecurefunc("GameTooltip_SetDefaultAnchor", function(tooltip, parent)
	if cursor then
        tooltip:SetOwner(parent, "ANCHOR_CURSOR")
    else
        tooltip:SetOwner(parent, "ANCHOR_NONE")
		tooltip:SetPoint(unpack(point))
    end	
	tooltip.default = 1
end)

GameTooltip:HookScript("OnUpdate", function(self, ...)
   if self:GetAnchorType() == "ANCHOR_CURSOR" then
	  local x, y = GetCursorPosition()
	  local effScale = self:GetEffectiveScale()
	  local width = self:GetWidth() or 0
	  self:ClearAllPoints()
	  self:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", x / effScale +5, y / effScale + 20)
   end
end)

function GameTooltip_ShowCompareItem(self, shift)
    if ( not self ) then
        self = GameTooltip;
    end
    local item, link = self:GetItem();
    if ( not link ) then
        return;
    end
     
    local shoppingTooltip1, shoppingTooltip2, shoppingTooltip3 = unpack(self.shoppingTooltips);
 
    local item1 = nil;
    local item2 = nil;
    local item3 = nil;
    local side = "left";
    if ( shoppingTooltip1:SetHyperlinkCompareItem(link, 1, shift, self) ) then
        item1 = true;
    end
    if ( shoppingTooltip2:SetHyperlinkCompareItem(link, 2, shift, self) ) then
        item2 = true;
    end
    if ( shoppingTooltip3:SetHyperlinkCompareItem(link, 3, shift, self) ) then
        item3 = true;
    end
 
    -- find correct side
    local rightDist = 0;
    local leftPos = self:GetLeft();
    local rightPos = self:GetRight();
    if ( not rightPos ) then
        rightPos = 0;
    end
    if ( not leftPos ) then
        leftPos = 0;
    end
 
    rightDist = GetScreenWidth() - rightPos;
 
    if (leftPos and (rightDist < leftPos)) then
        side = "left";
    else
        side = "right";
    end
 
    -- see if we should slide the tooltip
    if ( self:GetAnchorType() and self:GetAnchorType() ~= "ANCHOR_PRESERVE" ) then
        local totalWidth = 0;
        if ( item1  ) then
            totalWidth = totalWidth + shoppingTooltip1:GetWidth();
        end
        if ( item2  ) then
            totalWidth = totalWidth + shoppingTooltip2:GetWidth();
        end
        if ( item3  ) then
            totalWidth = totalWidth + shoppingTooltip3:GetWidth();
        end
 
        if ( (side == "left") and (totalWidth > leftPos) ) then
            self:SetAnchorType(self:GetAnchorType(), (totalWidth - leftPos), 0);
        elseif ( (side == "right") and (rightPos + totalWidth) >  GetScreenWidth() ) then
            self:SetAnchorType(self:GetAnchorType(), -((rightPos + totalWidth) - GetScreenWidth()), 0);
        end
    end
 
    -- anchor the compare tooltips
   if ( item3 ) then
        shoppingTooltip3:SetOwner(self, "ANCHOR_NONE");
        shoppingTooltip3:ClearAllPoints();
        if ( side and side == "left" ) then
            shoppingTooltip3:SetPoint("TOPRIGHT", self, "TOPLEFT", -5, 0);
        else
            shoppingTooltip3:SetPoint("TOPLEFT", self, "TOPRIGHT", 5, 0);
        end
        shoppingTooltip3:SetHyperlinkCompareItem(link, 3, shift, self);
        shoppingTooltip3:Show();
    end
     
    if ( item1 ) then
        if( item3 ) then
            shoppingTooltip1:SetOwner(shoppingTooltip3, "ANCHOR_NONE");
        else
            shoppingTooltip1:SetOwner(self, "ANCHOR_NONE");
        end
        shoppingTooltip1:ClearAllPoints();
        if ( side and side == "left" ) then
            if( item3 ) then
                shoppingTooltip1:SetPoint("TOPRIGHT", shoppingTooltip3, "TOPLEFT", -5, 0);
            else
                shoppingTooltip1:SetPoint("TOPRIGHT", self, "TOPLEFT", -5, 0);
            end
        else
            if( item3 ) then
                shoppingTooltip1:SetPoint("TOPLEFT", shoppingTooltip3, "TOPRIGHT", 5, 0);
            else
                shoppingTooltip1:SetPoint("TOPLEFT", self, "TOPRIGHT", 5, 0);
            end
        end
        shoppingTooltip1:SetHyperlinkCompareItem(link, 1, shift, self);
        shoppingTooltip1:Show();
 
        if ( item2 ) then
            shoppingTooltip2:SetOwner(shoppingTooltip1, "ANCHOR_NONE");
            shoppingTooltip2:ClearAllPoints();
            if ( side and side == "left" ) then
                shoppingTooltip2:SetPoint("TOPRIGHT", shoppingTooltip1, "TOPLEFT", -5, 0);
            else
                shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", 5, 0);
            end
            shoppingTooltip2:SetHyperlinkCompareItem(link, 2, shift, self);
            shoppingTooltip2:Show();
        end
    end
end