﻿-- mount.lua
-- simple mount addon
-- by yleaf


local filtered_list = {    --某些不想召唤的坐骑,e.g:  26054,25953

}

local Critter = true --召唤随机宠物

local tinsert = table.insert

local SEA_LEGS = GetSpellInfo(73701)
local _, class = UnitClass'player'
local special = {
    VASHJIR = {
        [75207] = true, --Abyssal Seahorse
    },
    AHNQIRAJ = {
        [26054] = true,
        [25953] = true,
        [26056] = true,
        [26055] = true,
    }
}

local get_current_mount_type = function()
    if (IsIndoors()) then
        return
    elseif (UnitAura('player', SEA_LEGS)) then
        return 'VASHJIR'
    elseif (IsSwimming()) then
        return 'WATER'
    elseif (IsFlyableArea() and IsUsableSpell(60025)) then
        return 'AIR'
    elseif (IsUsableSpell(26054)) then
        return 'AHNQIRAJ'
    elseif (IsUsableSpell(43688)) then
        return 'GROUND'
    end
end

local is_empty = function(list)
    if (list and next(list)) then
        return false
    end
    return true
end

local in_the_list = function(item, list)
    if (item and list) then
        if (list[item]) then
            return true
		else
			return false
		end
    end
end

local has_flag = function(a, b)
    if (a and b) then
		if (b==1 and (a==23 or a==29 or a==31)) or (b==2 and (a==7 or a==15 or a==23 or a==31)) or (b==3 and a==31)then
			return true
		else
			return false
		end
	end
end

local _mount_list = {}
local get_mount_list = function(state)
    local list = wipe(_mount_list)
    local flag, special_lst
    if (state == 'VASHJIR') then
        special_lst = special.VASHJIR
    elseif (state == 'AHNQIRAJ') then
        special_lst = special.AHNQIRAJ
    elseif (state == 'GROUND') then
        flag = 1
    elseif (state == 'AIR') then
        flag = 2
    elseif (state == 'WATER') then
		flag = 3
    end

    if not (flag or special_lst) then return end

    for i = 1, GetNumCompanions'MOUNT' do
        local creatureID, creatureName, spellid, icon, issummoned,mountType = GetCompanionInfo('MOUNT', i)
        if (has_flag(mountType, flag) and not in_the_list(spellid, filtered_list)) or in_the_list(spellid, special_lst)  then
            tinsert(list, i)
        end
    end

    if (not is_empty(list)) then
        return list
    end
end

SlashCmdList.LEAF_MOUNT = function()
    if (InCombatLockdown()) then return end
    if (IsMounted()) then return Critter and SummonRandomCritter() or Dismount() end

    local state = get_current_mount_type()
    if (state) then
        local list = get_mount_list(state)

        if (list) then
            return CallCompanion('MOUNT', list[math.random(#list)])
        end
    end
end

SLASH_LEAF_MOUNT1 = '/mount'
SLASH_LEAF_MOUNT2 = '/yMount'

local yMountFrame = CreateFrame('Button', 'yMountFrame', UIParent, 'SecureActionButtonTemplate')
yMountFrame:SetAttribute('type', 'macro')

setglobal('BINDING_HEADER_yMount', 'yMount')
setglobal('BINDING_NAME_CLICK yMountFrame:LeftButton', '绑定随机坐骑按键')

local function SetMacroText(self)
	if InCombatLockdown() then self:RegisterEvent'PLAYER_REGEN_ENABLED'end
	self:UnregisterEvent'PLAYER_REGEN_ENABLED'
	local macrotext
	if IsFlyableArea() then
		macrotext = class == 'DRUID' and ('/cast [swimming]' .. GetSpellInfo(1066) ..
											';[combat]' .. GetSpellInfo(783) ..
											';[flyable,nocombat]' .. GetSpellInfo(40120) ..
											'\n/stopmacro [flyable][combat]' ..
											'\n/cancelform' ..
											'\n/mount'
		) or class == 'SHAMAN' and ('/cast [combat][mod:alt]'.. GetSpellInfo(2645) ..
									'\n/stopmacro [mod:alt]'..
									'\n/mount'
		) or '/mount'
	else
		macrotext = class == 'DRUID' and ('/cast [swimming]' .. GetSpellInfo(1066) ..
											';[combat]' .. GetSpellInfo(783) ..
											'\n/stopmacro [combat]' ..
											'\n/cancelform' ..
											'\n/mount'
		) or class == 'SHAMAN' and ('/cast [mod:alt][combat]'.. GetSpellInfo(2645) ..
									'\n/stopmacro [mod:alt]'..
									'\n/mount'
		) or '/mount'
	end
	yMountFrame:SetAttribute('macrotext', macrotext)
end

local addon = CreateFrame'Frame'
addon:SetScript('OnEvent', function(self, event, ...)
	SetMacroText(self)
end)

addon:RegisterEvent'PLAYER_LOGIN'
addon:RegisterEvent'COMPANION_LEARNED'
addon:RegisterEvent'ZONE_CHANGED'
addon:RegisterEvent'ZONE_CHANGED_INDOORS'
addon:RegisterEvent'ZONE_CHANGED_NEW_AREA'
addon:RegisterEvent'WORLD_MAP_UPDATE'